#include "A.hpp"
#include "B.hpp"
#include "Base.hpp"
#include "C.hpp"
#include "identify.hpp"
#include "generate.hpp"

#include <iostream>

int main()
{
	std::cout << "identify PTR A: ";
	{
		A tmp;
		identify(&tmp);
	}
	std::cout << std::endl;

	std::cout << "identify PTR B: ";
	{
		B tmp;
		identify(&tmp);
	}
	std::cout << std::endl;
	
	std::cout << "identify PTR C: ";
	{
		C tmp;
		identify(&tmp);
	}
	std::cout << std::endl;

	std::cout << "identify REF A: ";
	{
		A tmp;
		identify(tmp);
	}
	std::cout << std::endl;

	std::cout << "identify REF B: ";
	{
		B tmp;
		identify(tmp);
	}
	std::cout << std::endl;
	
	std::cout << "identify REF C: ";
	{
		C tmp;
		identify(tmp);
	}
	std::cout << std::endl;

	for (int i = 0; i != 10; i++)
	{
		Base* tmp = generate();
		identify(tmp);
		delete(tmp);
		std::cout << std::endl;
	}
}
